<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelBooking StructType
 * @subpackage Structs
 */
class CancelBooking extends AbstractStructBase
{
    /**
     * The BookingID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BookingID;
    /**
     * The EmailId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $EmailId;
    /**
     * Constructor method for CancelBooking
     * @uses CancelBooking::setBookingID()
     * @uses CancelBooking::setEmailId()
     * @param string $bookingID
     * @param string $emailId
     */
    public function __construct($bookingID = null, $emailId = null)
    {
        $this
            ->setBookingID($bookingID)
            ->setEmailId($emailId);
    }
    /**
     * Get BookingID value
     * @return string|null
     */
    public function getBookingID()
    {
        return $this->BookingID;
    }
    /**
     * Set BookingID value
     * @param string $bookingID
     * @return \StructType\CancelBooking
     */
    public function setBookingID($bookingID = null)
    {
        // validation for constraint: string
        if (!is_null($bookingID) && !is_string($bookingID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bookingID)), __LINE__);
        }
        $this->BookingID = $bookingID;
        return $this;
    }
    /**
     * Get EmailId value
     * @return string|null
     */
    public function getEmailId()
    {
        return $this->EmailId;
    }
    /**
     * Set EmailId value
     * @param string $emailId
     * @return \StructType\CancelBooking
     */
    public function setEmailId($emailId = null)
    {
        // validation for constraint: string
        if (!is_null($emailId) && !is_string($emailId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($emailId)), __LINE__);
        }
        $this->EmailId = $emailId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelBooking
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
